      SUBROUTINE QST2D(RINT,A,B,F,N,EPS,K,IND,R,IERR)
         INTEGER IERR,IND,K,N
         DOUBLE PRECISION A,B,EPS,R,RINT
         DIMENSION IND(N),R(N,2),RINT(N)
         EXTERNAL UTQS12
         INTEGER I,J,K1,K2
         DOUBLE PRECISION E,H,RH,RI
       IERR = 0
       DO 10 I = 1, N
          R(I,2) = 0.D0
          IND(I) = 0
   10  CONTINUE
       K1 = K
       IF (K .LE. 0) K1 = 1
       CALL F(A,RINT,IND)
       CALL F(B,R,IND)
       H = (B - A)/K1
       DO 20 I = 1, N
          RINT(I) = (RINT(I) + R(I,1))*H*.5D0
   20  CONTINUE
       IF (K1 .EQ. 1) GO TO 50
          K2 = K1 - 1
          DO 40 J = 1, K2
             CALL F(A + J*H,R,IND)
             DO 30 I = 1, N
                RINT(I) = RINT(I) + R(I,1)*H
   30        CONTINUE
   40     CONTINUE
   50  CONTINUE
       IF (EPS .LE. 0.D0) GO TO 100
   60  CONTINUE
       H = H*.5D0
       DO 80 J = 1, K1
          CALL F(A + (2.D0*J - 1.D0)*H,R,IND)
          DO 70 I = 1, N
             R(I,2) = R(I,2) + R(I,1)
   70     CONTINUE
   80  CONTINUE
       K2 = 1
       DO 90 I = 1, N
          IF (IND(I) .GT. 0) GO TO 90
             RH = R(I,2)*H
             RI = RINT(I)*.5D0
             RINT(I) = RH + RI
             E = DABS(RH-RI)/(1.D0 + DABS(RINT(I)))
             IF (E .LE. EPS) IND(I) = K1
             IF (IND(I) .EQ. 0) K2 = 0
             R(I,2) = 0.D0
   90  CONTINUE
       IF (K2 .GT. 0) GO TO 100
          K1 = K1 + K1
          IF (K1 .LE. 1048576) GO TO 60
             IERR = 65
             CALL UTQS12(IERR,8)
  100     RETURN
      END
